/*
 * Rectangles.java
 *
 * Created on 19. jen 2006, 23:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pa161.uloha_2;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author xmatena
 */
public class Rectangles {
     public static int DEPTH = 9; //counting from 0
     public static boolean VERBOSE = false;
     public static boolean RANDOM = true;
   
    /** Creates a new instance of Rectangles */
    public Rectangles() {
    }
    
    public static void main(String[] args) {
        RectBoard goal = new RectBoard(1,2,3,8,0,4,7,6,5);
        System.out.println(goal.drawState());
        RectBoard b;
        RectBoard d = new RectBoard();
        
        List possibleMovesList;
        List movesDeltaList;
        int badPlaceCounter = 0;
        int manhattanCounter = 0;
        
        b = new RectBoard();
        if (RANDOM) {
            b = getRandomBoard();
        } else {
            b.setBoard(goal.getBoard());
            b.moveField(1,1,2,1);
            b.moveField(2,1,2,0);
            b.moveField(2,0,1,0);
            b.moveField(1,0,0,0);
            b.moveField(0,0,0,1);
            b.moveField(0,1,0,2);
            b.moveField(0,2,1,2);

        }
        d.setBoard(b.getBoard());
        System.out.println(b.drawState());
        System.out.println("\n-------------");
        ReturnStruct s;
        while (!b.equals(goal)) {
            s = b.getBoardAfterBestMove(goal,1, DEPTH);
            b = s.getRb();
            System.out.println(b.drawState());
            if (!VERBOSE) {
                System.out.println(s.getLowestCount());
            }
            badPlaceCounter++;
        }
        System.out.println(b.drawState());
        System.out.println("Needed "+badPlaceCounter +" steps with Bad Place heuristics.");
     
        while (!d.equals(goal)) {
            s = d.getBoardAfterBestMove(goal,2, DEPTH);
            d = s.getRb();
            System.out.println(d.drawState());
            if (!VERBOSE) {
                System.out.println(s.getLowestCount() + "\n");
            }
            manhattanCounter++;
        }
        System.out.println(d.drawState());
        System.out.println("Needed "+manhattanCounter +" steps with Manhattan heuristics.");
        
        
        
        
    }
    
    public static RectBoard getRandomBoard() {
        Random r = new Random();
        
        byte b[] = {0,0,0,0,0,0,0,0,0};
        byte result;
        List choice = new ArrayList();
        choice.add(new Integer(0));
        choice.add(1);
        choice.add(2);
        choice.add(3);
        choice.add(4);
        choice.add(5);
        choice.add(6);
        choice.add(7);
        choice.add(8);
        
        for(int i = 0; i<8; i++) {
            b[i] = (byte)  ((Integer) choice.remove(r.nextInt(9-i))).intValue();
            r = new Random();
        }
        b[8] = (byte)  ((Integer) choice.remove(0)).intValue();
        return new RectBoard(b[0],b[1],b[2],b[3],b[4],b[5],b[6],b[7],b[8]);
    }
}
